//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright ""
#property link      ""
#property indicator_separate_window

#property indicator_buffers    8
#property indicator_color1     LimeGreen
#property indicator_color2     LimeGreen
#property indicator_color3     PaleVioletRed
#property indicator_color4     PaleVioletRed
#property indicator_color5     DimGray
#property indicator_color6     RoyalBlue
#property indicator_color7     Green
#property indicator_color8     Red
#property indicator_width1     2
#property indicator_width3     2
#property indicator_width6     3
#property indicator_width7     2
#property indicator_width8     2
#property indicator_levelcolor DarkOliveGreen

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    StochPeriod  = 14;
extern int    StochSlowing = 10;
extern int    StochPrice   =  0;
extern int    MA1_Period   =  3;
extern int    MA1_Mode     =  1;
extern int    MA2_Period   =  5;
extern int    MA2_Mode     =  1;
extern double multiplier   =  2;
extern double levelOs      = -30;
extern double levelOb      = 30;
extern bool   Interpolate  = true;

//
//
//
//
//

double STO_Buffer[];
double MA1_Buffer[];
double MA2_Buffer[];
double hiUu[];
double hiUd[];
double hiDd[];
double hiDu[];
double hiLi[];
double trend[];
double slope[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, hiUu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, hiUd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, hiDd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, hiDu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4, hiLi);
   SetIndexBuffer(5, STO_Buffer);
   SetIndexBuffer(6, MA1_Buffer);
   SetIndexBuffer(7, MA2_Buffer);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
   SetLevelValue(2,0);
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" STO 2SigMA ("+StochPeriod+","+StochSlowing+","+MA1_Period+","+MA2_Period+")");
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
   SetIndexLabel(3,"");
   SetIndexLabel(4,"");
   SetIndexLabel(5,"");
   SetIndexLabel(6,"");
   SetIndexLabel(7,"");
   return(0);
}
int deinit(){ return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { hiUu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
      if (ArrayRange(slope,0)!=Bars) ArrayResize(slope,Bars);   
      for(i=limit;           i>=0;i--)      STO_Buffer[i] = iStochastic(NULL,0,StochPeriod,1,StochSlowing,MODE_SMA,StochPrice,MODE_MAIN,i)-50;
      for(i=limit;           i>=0;i--)      MA1_Buffer[i] = iMAOnArray(STO_Buffer,0,MA1_Period,0,MA1_Mode,i);
      for(i=limit,r=Bars-i-1;i>=0;i--,r++){ MA2_Buffer[i] = iMAOnArray(MA1_Buffer,0,MA2_Period,0,MA2_Mode,i);
         hiLi[i] = (MA1_Buffer[i]-MA2_Buffer[i])*multiplier;
         hiUu[i] = EMPTY_VALUE;
         hiUd[i] = EMPTY_VALUE;
         hiDd[i] = EMPTY_VALUE;
         hiDu[i] = EMPTY_VALUE;
         trend[r]= trend[r-1];
         slope[r]= slope[r-1];
            if (hiLi[i]>0)         trend[r] =  1;
            if (hiLi[i]<0)         trend[r] = -1;
            if (hiLi[i]>hiLi[i+1]) slope[r] =  1;
            if (hiLi[i]<hiLi[i+1]) slope[r] = -1;
            if (trend[r]==1)
               if (slope[r]==1) 
                     hiUu[i] = hiLi[i];
               else  hiUd[i] = hiLi[i];    
            if (trend[r]==-1)
               if (slope[r]==-1) 
                     hiDd[i] = hiLi[i];
               else  hiDu[i] = hiLi[i];    
      }
      return(0);
   }      
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));      
   if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
   if (ArrayRange(slope,0)!=Bars) ArrayResize(slope,Bars);   
   for(i=limit,r=Bars-i-1;i>=0;i--,r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         STO_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StochPeriod,StochSlowing,StochPrice,MA1_Period,MA1_Mode,MA2_Period,MA2_Mode,5,y);
         MA1_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StochPeriod,StochSlowing,StochPrice,MA1_Period,MA1_Mode,MA2_Period,MA2_Mode,6,y);
         MA2_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StochPeriod,StochSlowing,StochPrice,MA1_Period,MA1_Mode,MA2_Period,MA2_Mode,7,y);
         hiLi[i] = (MA1_Buffer[i]-MA2_Buffer[i])*multiplier;
         hiUu[i] = EMPTY_VALUE;
         hiUd[i] = EMPTY_VALUE;
         hiDd[i] = EMPTY_VALUE;
         hiDu[i] = EMPTY_VALUE;
         trend[r]= trend[r-1];
         slope[r]= slope[r-1];
            if (hiLi[i]>0)         trend[r] =  1;
            if (hiLi[i]<0)         trend[r] = -1;
            if (hiLi[i]>hiLi[i+1]) slope[r] =  1;
            if (hiLi[i]<hiLi[i+1]) slope[r] = -1;
            if (trend[r]==1)
               if (slope[r]==1) 
                     hiUu[i] = hiLi[i];
               else  hiUd[i] = hiLi[i];    
            if (trend[r]==-1)
               if (slope[r]==-1) 
                     hiDd[i] = hiLi[i];
               else  hiDu[i] = hiLi[i];    
            if (!Interpolate || (i>0 && y==iBarShift(NULL,timeFrame,Time[i-1]))) continue;
   
            //
            //
            //
            //
            //
   
            int n,l;
            datetime time = iTime(NULL,timeFrame,y);
               for(n = 1; (i+n)< Bars && Time[i+n] >= time; n++) continue;	
               for(l = 1; l < n && (i+l<Bars) && (i+n)<Bars; l++)
                  {
                     STO_Buffer[i+l] = STO_Buffer[i] + (STO_Buffer[i+n]-STO_Buffer[i])*l/n;
                     MA1_Buffer[i+l] = MA1_Buffer[i] + (MA1_Buffer[i+n]-MA1_Buffer[i])*l/n;
                     MA2_Buffer[i+l] = MA2_Buffer[i] + (MA2_Buffer[i+n]-MA2_Buffer[i])*l/n;
                     hiLi[i+l]       = hiLi[i]       + (hiLi[i+n]      -hiLi[i]      )*l/n;
                           if (hiUu[i+l]!=EMPTY_VALUE) hiUu[i+l]=hiLi[i+l];
                           if (hiUd[i+l]!=EMPTY_VALUE) hiUd[i+l]=hiLi[i+l];
                           if (hiDu[i+l]!=EMPTY_VALUE) hiDu[i+l]=hiLi[i+l];
                           if (hiDd[i+l]!=EMPTY_VALUE) hiDd[i+l]=hiLi[i+l];
                  }                     
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}


